Index: /LMDZ6/branches/cirrus/libf/misc/readTracFiles_mod.f90
===================================================================
--- /LMDZ6/branches/cirrus/libf/misc/readTracFiles_mod.f90	(revision 5201)
+++ /LMDZ6/branches/cirrus/libf/misc/readTracFiles_mod.f90	(revision 5202)
@@ -1808,4 +2596,67 @@
   IF(.NOT.PRESENT(phases)) out = [( addPhase_i1(s(k), ipha, known_phases), k=1, SIZE(s) )]
 END FUNCTION addPhase_im
+!==============================================================================================================================
+
+
+!==============================================================================================================================
+!=== APPEND TRACERS DATABASE "tracs" WITH TRACERS/KEYS "tname"/"keys" ; SAME FOR INTERNAL DATABASE "tracers" ==================
+!==============================================================================================================================
+LOGICAL FUNCTION addTracer_1(tname, keys, tracs) RESULT(lerr)
+  CHARACTER(LEN=*),             INTENT(IN)    :: tname
+  TYPE(keys_type),              INTENT(IN)    ::  keys
+  TYPE(trac_type), ALLOCATABLE, INTENT(INOUT) :: tracs(:)
+  TYPE(trac_type), ALLOCATABLE :: tr(:)
+  CHARACTER(LEN=maxlen), ALLOCATABLE :: tnames(:)
+  INTEGER :: nt, ix
+  IF(ALLOCATED(tracs)) THEN
+     lerr = getKey('name', tnames, ky=tracs(:)%keys); IF(lerr) RETURN
+     nt = SIZE(tracs)
+     ix = strIdx(tnames, tname)
+     CALL msg('Modifying existing tracer "'//TRIM(tname)//'"', modname, ix /= 0)
+     CALL msg('Appending with tracer "'    //TRIM(tname)//'"', modname, ix == 0)
+     IF(ix == 0) THEN
+        ix = nt+1; ALLOCATE(tr(nt+1)); tr(1:nt) = tracs(1:nt); CALL MOVE_ALLOC(FROM=tr, TO=tracs)
+     END IF
+  ELSE
+     CALL msg('Creating a tracer descriptor with tracer "'//TRIM(tname)//'"', modname)
+     ix = 1; ALLOCATE(tracs(1))
+  END IF
+  CALL addKey('name', tname, tracs(ix)%keys)
+  tracs(ix)%name = tname
+  tracs(ix)%keys = keys
+
+END FUNCTION addTracer_1
+!==============================================================================================================================
+LOGICAL FUNCTION addTracer_1def(tname, keys) RESULT(lerr)
+  CHARACTER(LEN=*),             INTENT(IN)    :: tname
+  TYPE(keys_type),              INTENT(IN)    ::  keys
+  lerr = addTracer_1(tname, keys, tracers)
+END FUNCTION addTracer_1def
+!==============================================================================================================================
+
+
+!==============================================================================================================================
+LOGICAL FUNCTION delTracer_1(tname, tracs) RESULT(lerr)
+  CHARACTER(LEN=*),                     INTENT(IN)    :: tname
+  TYPE(trac_type), ALLOCATABLE, TARGET, INTENT(INOUT) :: tracs(:)
+  TYPE(trac_type), ALLOCATABLE :: tr(:)
+  CHARACTER(LEN=maxlen), ALLOCATABLE :: tnames(:)
+  INTEGER :: nt, ix
+  lerr = .NOT.ALLOCATED(tracs)
+  IF(fmsg('Can''t remove tracer "'//TRIM(tname)//'" from an empty tracers descriptor', modname, lerr)) RETURN
+  nt = SIZE(tracs)
+  lerr = getKey('name', tnames, ky=tracs(:)%keys); IF(lerr) RETURN
+  ix = strIdx(tnames, tname)
+  CALL msg('Removing tracer "'             //TRIM(tname)//'"', modname, ix /= 0)
+  CALL msg('Can''t remove unknown tracer "'//TRIM(tname)//'"', modname, ix == 0)
+  IF(ix /= 0) THEN
+     ALLOCATE(tr(nt-1)); tr(1:ix-1) = tracs(1:ix-1); tr(ix:nt-1) = tracs(ix+1:nt); CALL MOVE_ALLOC(FROM=tr, TO=tracs)
+  END IF
+END FUNCTION delTracer_1
+!==============================================================================================================================
+LOGICAL FUNCTION delTracer_1def(tname) RESULT(lerr)
+  CHARACTER(LEN=*), INTENT(IN) :: tname
+  lerr = delTracer(tname, tracers)
+END FUNCTION delTracer_1def
 !==============================================================================================================================
 
@@ -1908,76 +2759,3 @@
 !==============================================================================================================================
 
-
-!==============================================================================================================================
-!=== GET THE NAME(S) OF THE ANCESTOR(S) OF TRACER(S) "tname" AT GENERATION "igen"  IN THE TRACERS DESCRIPTORS LIST "tr" =======
-!==============================================================================================================================
-SUBROUTINE ancestor_1(t, out, tname, igen)
-  TYPE(trac_type),       INTENT(IN)  :: t(:)
-  CHARACTER(LEN=maxlen), INTENT(OUT) :: out
-  CHARACTER(LEN=*),      INTENT(IN)  :: tname
-  INTEGER,     OPTIONAL, INTENT(IN)  :: igen
-!------------------------------------------------------------------------------------------------------------------------------
-  INTEGER :: ix
-  CALL idxAncestor_1(t, ix, tname, igen)
-  out = ''; IF(ix /= 0) out = t(ix)%name
-END SUBROUTINE ancestor_1
-!==============================================================================================================================
-SUBROUTINE ancestor_mt(t, out, tname, igen)
-  TYPE(trac_type),       INTENT(IN)  :: t(:)
-  CHARACTER(LEN=*),      INTENT(IN)  :: tname(:)
-  CHARACTER(LEN=maxlen), INTENT(OUT) :: out(SIZE(tname))
-  INTEGER,     OPTIONAL, INTENT(IN)  :: igen
-!------------------------------------------------------------------------------------------------------------------------------
-  INTEGER :: ix(SIZE(tname))
-  CALL idxAncestor_mt(t, ix, tname, igen)
-  out(:) = ''; WHERE(ix /= 0) out = t(ix)%name
-END SUBROUTINE ancestor_mt
-!==============================================================================================================================
-SUBROUTINE ancestor_m(t, out, igen)
-  TYPE(trac_type),       INTENT(IN)  :: t(:)
-  CHARACTER(LEN=maxlen), INTENT(OUT) :: out(SIZE(t))
-  INTEGER,     OPTIONAL, INTENT(IN)  :: igen
-!------------------------------------------------------------------------------------------------------------------------------
-  INTEGER :: ix(SIZE(t))
-  CALL idxAncestor_m(t, ix, igen)
-  out(:) = ''; WHERE(ix /= 0) out = t(ix)%name
-END SUBROUTINE ancestor_m
-!==============================================================================================================================
-
-
-!==============================================================================================================================
-!=== GET THE INDEX(ES) OF THE GENERATION "igen" ANCESTOR(S) OF "tname" (t%name IF UNSPECIFIED) IN THE "t" LIST ================
-!==============================================================================================================================
-SUBROUTINE idxAncestor_1(t, idx, tname, igen)
-  TYPE(trac_type),   INTENT(IN)  :: t(:)
-  INTEGER,           INTENT(OUT) :: idx
-  CHARACTER(LEN=*),  INTENT(IN)  :: tname
-  INTEGER, OPTIONAL, INTENT(IN)  :: igen
-  INTEGER :: ig
-  ig = 0; IF(PRESENT(igen)) ig = igen
-  idx = strIdx(t(:)%name, tname)
-  IF(idx == 0)                 RETURN            !--- Tracer not found
-  IF(t(idx)%iGeneration <= ig) RETURN            !--- Tracer has a lower generation number than asked generation 'igen"
-  DO WHILE(t(idx)%iGeneration > ig); idx = strIdx(t(:)%name, t(idx)%parent); END DO
-END SUBROUTINE idxAncestor_1
-!------------------------------------------------------------------------------------------------------------------------------
-SUBROUTINE idxAncestor_mt(t, idx, tname, igen)
-  TYPE(trac_type),   INTENT(IN)  :: t(:)
-  CHARACTER(LEN=*),  INTENT(IN)  :: tname(:)
-  INTEGER,           INTENT(OUT) :: idx(SIZE(tname))
-  INTEGER, OPTIONAL, INTENT(IN)  :: igen
-  INTEGER :: ix
-  DO ix = 1, SIZE(tname); CALL idxAncestor_1(t, idx(ix), tname(ix), igen); END DO
-END SUBROUTINE idxAncestor_mt
-!------------------------------------------------------------------------------------------------------------------------------
-SUBROUTINE idxAncestor_m(t, idx, igen)
-  TYPE(trac_type),   INTENT(IN)  :: t(:)
-  INTEGER,           INTENT(OUT) :: idx(SIZE(t))
-  INTEGER, OPTIONAL, INTENT(IN)  :: igen
-  INTEGER :: ix
-  DO ix = 1, SIZE(t); CALL idxAncestor_1(t, idx(ix), t(ix)%name, igen); END DO
-END SUBROUTINE idxAncestor_m
-!==============================================================================================================================
-
-
 END MODULE readTracFiles_mod
Index: /LMDZ6/branches/cirrus/libf/misc/strings_mod.F90
===================================================================
--- /LMDZ6/branches/cirrus/libf/misc/strings_mod.F90	(revision 5201)
+++ /LMDZ6/branches/cirrus/libf/misc/strings_mod.F90	(revision 5202)
@@ -10,5 +10,5 @@
   PUBLIC :: is_numeric, bool2str, int2str, real2str, dble2str
   PUBLIC :: reduceExpr, str2bool, str2int, str2real, str2dble
-  PUBLIC :: addQuotes, checkList, removeComment, test
+  PUBLIC :: addQuotes, checkList, removeComment
 
   INTERFACE get_in;     MODULE PROCEDURE getin_s,  getin_i,  getin_r,  getin_l;  END INTERFACE get_in
@@ -22,8 +22,10 @@
   INTERFACE strCount;   MODULE PROCEDURE  strCount_m1, strCount_11, strCount_1m; END INTERFACE strCount
   INTERFACE strReplace; MODULE PROCEDURE strReplace_1,             strReplace_m; END INTERFACE strReplace
-  INTERFACE cat;        MODULE PROCEDURE   horzcat_s1,  horzcat_i1,  horzcat_r1, &
-!                 horzcat_d1,  horzcat_dm,
-                                           horzcat_sm,  horzcat_im,  horzcat_rm; END INTERFACE cat
-  INTERFACE find;         MODULE PROCEDURE    strFind,    find_int,    find_boo; END INTERFACE find
+  INTERFACE cat;        MODULE PROCEDURE  horzcat_s00, horzcat_i00, horzcat_r00,  & !horzcat_d00, &
+                                          horzcat_s10, horzcat_i10, horzcat_r10,  & !horzcat_d10, &
+                                          horzcat_s11, horzcat_i11, horzcat_r11,  & !horzcat_d11, &
+                                          horzcat_s21, horzcat_i21, horzcat_r21; END INTERFACE cat !horzcat_d21
+  INTERFACE strFind;      MODULE PROCEDURE strFind_1, strFind_m;                 END INTERFACE strFind
+  INTERFACE find;         MODULE PROCEDURE strFind_1, strFind_m, intFind_1, intFind_m, booFind; END INTERFACE find
   INTERFACE dispOutliers; MODULE PROCEDURE dispOutliers_1, dispOutliers_2; END INTERFACE dispOutliers
   INTERFACE reduceExpr;   MODULE PROCEDURE   reduceExpr_1,   reduceExpr_m; END INTERFACE reduceExpr
@@ -36,15 +38,8 @@
 CONTAINS
 
-!==============================================================================================================================
-LOGICAL FUNCTION test(lcond, lout) RESULT(lerr)
-  LOGICAL, INTENT(IN)  :: lcond
-  LOGICAL, INTENT(OUT) :: lout
-  lerr = lcond; lout = lcond
-END FUNCTION test
-!==============================================================================================================================
-
 
 !==============================================================================================================================
 SUBROUTINE init_printout(lunout_, prt_level_)
+  IMPLICIT NONE
   INTEGER, INTENT(IN) :: lunout_, prt_level_
   lunout    = lunout_
@@ -58,5 +53,6 @@
 !==============================================================================================================================
 SUBROUTINE getin_s(nam, val, def)
-USE ioipsl_getincom, ONLY: getin
+  USE ioipsl_getincom, ONLY: getin
+  IMPLICIT NONE
   CHARACTER(LEN=*), INTENT(IN)    :: nam
   CHARACTER(LEN=*), INTENT(INOUT) :: val
@@ -67,5 +63,6 @@
 !==============================================================================================================================
 SUBROUTINE getin_i(nam, val, def)
-USE ioipsl_getincom, ONLY: getin
+  USE ioipsl_getincom, ONLY: getin
+  IMPLICIT NONE
   CHARACTER(LEN=*), INTENT(IN)    :: nam
   INTEGER,          INTENT(INOUT) :: val
@@ -76,5 +73,6 @@
 !==============================================================================================================================
 SUBROUTINE getin_r(nam, val, def)
-USE ioipsl_getincom, ONLY: getin
+  USE ioipsl_getincom, ONLY: getin
+  IMPLICIT NONE
   CHARACTER(LEN=*), INTENT(IN)    :: nam
   REAL,             INTENT(INOUT) :: val
@@ -85,5 +83,6 @@
 !==============================================================================================================================
 SUBROUTINE getin_l(nam, val, def)
-USE ioipsl_getincom, ONLY: getin
+  USE ioipsl_getincom, ONLY: getin
+  IMPLICIT NONE
   CHARACTER(LEN=*), INTENT(IN)    :: nam
   LOGICAL,          INTENT(INOUT) :: val
@@ -99,4 +98,5 @@
 !==============================================================================================================================
 SUBROUTINE msg_1(str, modname, ll, unit)
+  IMPLICIT NONE
   !--- Display a simple message "str". Optional parameters:
   !    * "modname": module name, displayed in front of the message (with ": " separator) if present.
@@ -118,4 +118,5 @@
 !==============================================================================================================================
 SUBROUTINE msg_m(str, modname, ll, unit, nmax)
+  IMPLICIT NONE
   !--- Same as msg_1 with multiple strings that are stacked (separator: coma) on up to "nmax" full lines.
   CHARACTER(LEN=*),           INTENT(IN) :: str(:)
@@ -138,4 +139,5 @@
 !==============================================================================================================================
 LOGICAL FUNCTION fmsg_1(str, modname, ll, unit) RESULT(l)
+  IMPLICIT NONE
   CHARACTER(LEN=*),           INTENT(IN) :: str
   CHARACTER(LEN=*), OPTIONAL, INTENT(IN) :: modname
@@ -152,4 +154,5 @@
 !==============================================================================================================================
 LOGICAL FUNCTION fmsg_m(str, modname, ll, unit, nmax) RESULT(l)
+  IMPLICIT NONE
   CHARACTER(LEN=*),           INTENT(IN)  :: str(:)
   CHARACTER(LEN=*), OPTIONAL, INTENT(IN) :: modname
@@ -173,4 +176,5 @@
 !==============================================================================================================================
 ELEMENTAL CHARACTER(LEN=maxlen) FUNCTION strLower(str) RESULT(out)
+  IMPLICIT NONE
   CHARACTER(LEN=*), INTENT(IN) :: str
   INTEGER :: k
@@ -182,4 +186,5 @@
 !==============================================================================================================================
 ELEMENTAL CHARACTER(LEN=maxlen) FUNCTION strUpper(str) RESULT(out)
+  IMPLICIT NONE
   CHARACTER(LEN=*), INTENT(IN) :: str
   INTEGER :: k
@@ -199,4 +204,5 @@
 !==============================================================================================================================
 CHARACTER(LEN=maxlen) FUNCTION strHead_1(str, sep, lBackward) RESULT(out)
+  IMPLICIT NONE
   CHARACTER(LEN=*),           INTENT(IN) :: str
   CHARACTER(LEN=*), OPTIONAL, INTENT(IN) :: sep
@@ -214,4 +220,5 @@
 !==============================================================================================================================
 FUNCTION strHead_m(str, sep, lBackward) RESULT(out)
+  IMPLICIT NONE
   CHARACTER(LEN=maxlen),     ALLOCATABLE :: out(:)
   CHARACTER(LEN=*),           INTENT(IN) :: str(:)
@@ -235,4 +242,5 @@
 !==============================================================================================================================
 CHARACTER(LEN=maxlen) FUNCTION strTail_1(str, sep, lBackWard) RESULT(out)
+  IMPLICIT NONE
   CHARACTER(LEN=*),           INTENT(IN) :: str
   CHARACTER(LEN=*), OPTIONAL, INTENT(IN) :: sep
@@ -250,4 +258,5 @@
 !==============================================================================================================================
 FUNCTION strTail_m(str, sep, lBackWard) RESULT(out)
+  IMPLICIT NONE
   CHARACTER(LEN=maxlen),     ALLOCATABLE :: out(:)
   CHARACTER(LEN=*),           INTENT(IN) :: str(:)
@@ -271,4 +280,5 @@
 !==============================================================================================================================
 FUNCTION strStack(str, sep, mask) RESULT(out)
+  IMPLICIT NONE
   CHARACTER(LEN=:),          ALLOCATABLE :: out
   CHARACTER(LEN=*),           INTENT(IN) :: str(:)
@@ -292,4 +302,5 @@
 !==============================================================================================================================
 FUNCTION strStackm(str, sep, nmax) RESULT(out)
+  IMPLICIT NONE
   CHARACTER(LEN=maxlen),     ALLOCATABLE :: out(:)
   CHARACTER(LEN=*),           INTENT(IN) :: str(:)
@@ -324,4 +335,5 @@
 !==============================================================================================================================
 SUBROUTINE strClean_1(str)
+  IMPLICIT NONE
   CHARACTER(LEN=*), INTENT(INOUT) :: str
   INTEGER :: k, n, m
@@ -337,4 +349,5 @@
 !==============================================================================================================================
 SUBROUTINE strClean_m(str)
+  IMPLICIT NONE
   CHARACTER(LEN=*), INTENT(INOUT) :: str(:)
   INTEGER :: k
@@ -349,4 +362,5 @@
 !==============================================================================================================================
 SUBROUTINE strReduce_1(str, nb)
+  IMPLICIT NONE
   CHARACTER(LEN=*), ALLOCATABLE, INTENT(INOUT) :: str(:)
   INTEGER,          OPTIONAL,    INTENT(OUT)   :: nb
@@ -366,4 +380,5 @@
 !==============================================================================================================================
 SUBROUTINE strReduce_2(str1, str2)
+  IMPLICIT NONE
   CHARACTER(LEN=*),   ALLOCATABLE, INTENT(INOUT) :: str1(:)
   CHARACTER(LEN=*),                INTENT(IN)    :: str2(:)
@@ -392,4 +407,5 @@
 !==============================================================================================================================
 INTEGER FUNCTION strIdx_1(str, s) RESULT(out)
+  IMPLICIT NONE
   CHARACTER(LEN=*), INTENT(IN) :: str(:), s
   DO out = 1, SIZE(str); IF(str(out) == s) EXIT; END DO
@@ -398,4 +414,5 @@
 !==============================================================================================================================
 FUNCTION strIdx_m(str, s, n) RESULT(out)
+  IMPLICIT NONE
   CHARACTER(LEN=*),  INTENT(IN)  :: str(:), s(:)
   INTEGER, OPTIONAL, INTENT(OUT) :: n
@@ -412,5 +429,6 @@
 !=== GET THE INDEX LIST OF THE ELEMENTS OF "str(:)" EQUAL TO "s" AND OPTIONALY, ITS LENGTH "n" ================================
 !==============================================================================================================================
-FUNCTION strFind(str, s, n) RESULT(out)
+FUNCTION strFind_1(str, s, n) RESULT(out)
+  IMPLICIT NONE
   CHARACTER(LEN=*),  INTENT(IN)  :: str(:), s
   INTEGER, OPTIONAL, INTENT(OUT) :: n
@@ -420,7 +438,19 @@
   out = PACK( [(k, k=1, SIZE(str(:), DIM=1))], MASK = str(:) == s )
   IF(PRESENT(n)) n = SIZE(out(:), DIM=1)
-END FUNCTION strFind
-!==============================================================================================================================
-FUNCTION find_int(i,j,n) RESULT(out)
+END FUNCTION strFind_1
+!==============================================================================================================================
+FUNCTION strFind_m(str, s, n) RESULT(out)
+  IMPLICIT NONE
+  CHARACTER(LEN=*),  INTENT(IN)  :: str(:), s(:)
+  INTEGER, OPTIONAL, INTENT(OUT) :: n
+  INTEGER,           ALLOCATABLE :: out(:)
+!------------------------------------------------------------------------------------------------------------------------------
+  INTEGER :: k
+  out = [(strFind_1(str, s(k)), k=1, SIZE(s))]
+  IF(PRESENT(n)) n = SIZE(out(:), DIM=1)
+END FUNCTION strFind_m
+!==============================================================================================================================
+FUNCTION intFind_1(i,j,n) RESULT(out)
+  IMPLICIT NONE
   INTEGER,           INTENT(IN)  :: i(:), j
   INTEGER, OPTIONAL, INTENT(OUT) :: n
@@ -430,8 +460,20 @@
   out = PACK( [(k, k=1, SIZE(i(:), DIM=1))], MASK = i(:) == j )
   IF(PRESENT(n)) n = SIZE(out(:), DIM=1)
-END FUNCTION find_int
-!==============================================================================================================================
-FUNCTION find_boo(l,n) RESULT(out)
-  LOGICAL,           INTENT(IN)  :: l(:)
+END FUNCTION intFind_1
+!==============================================================================================================================
+FUNCTION intFind_m(i,j,n) RESULT(out)
+  IMPLICIT NONE
+  INTEGER,           INTENT(IN)  :: i(:), j(:)
+  INTEGER, OPTIONAL, INTENT(OUT) :: n
+  INTEGER,           ALLOCATABLE :: out(:)
+!------------------------------------------------------------------------------------------------------------------------------
+  INTEGER :: k
+  out = [(intFind_1(i, j(k)), k=1, SIZE(j))]
+  IF(PRESENT(n)) n = SIZE(out(:), DIM=1)
+END FUNCTION intFind_m
+!==============================================================================================================================
+FUNCTION booFind(l,n) RESULT(out)
+   IMPLICIT NONE
+ LOGICAL,           INTENT(IN)  :: l(:)
   INTEGER, OPTIONAL, INTENT(OUT) :: n
   INTEGER,           ALLOCATABLE :: out(:)
@@ -440,5 +482,5 @@
   out = PACK( [(k, k=1, SIZE(l(:), DIM=1))], MASK = l(:) )
   IF(PRESENT(n)) n = SIZE(out(:), DIM=1)
-END FUNCTION find_boo
+END FUNCTION booFind
 !==============================================================================================================================
 
@@ -450,4 +492,5 @@
 !==============================================================================================================================
 LOGICAL FUNCTION strIdx_prv(rawList, del, ibeg, idx, idel, lSc) RESULT(lerr)
+  IMPLICIT NONE
   CHARACTER(LEN=*),  INTENT(IN)  :: rawList                          !--- String in which delimiters have to be identified
   CHARACTER(LEN=*),  INTENT(IN)  :: del(:)                           !--- List of delimiters
@@ -469,6 +512,6 @@
   END IF
 
-  IF(test(idx == 1 .AND. INDEX('+-',del(idel)) /= 0, lerr)) RETURN   !--- The front delimiter is different from +/-: error
-  IF(     idx /= 1 .AND. is_numeric(rawList(ibeg:idx-1)))   RETURN   !--- The input string head is a valid number
+  lerr = idx == 1 .AND. INDEX('+-',del(idel)) /= 0; IF(lerr) RETURN  !--- The front delimiter is different from +/-: error
+  IF(    idx /= 1 .AND. is_numeric(rawList(ibeg:idx-1)))     RETURN  !--- The input string head is a valid number
 
   !=== The string part in front of the 1st delimiter is not a valid number: search for next delimiter index "idx"
@@ -503,4 +546,5 @@
 !==============================================================================================================================
 LOGICAL FUNCTION strCount_11(rawList, delimiter, nb, lSc) RESULT(lerr)
+  IMPLICIT NONE
   CHARACTER(LEN=*),  INTENT(IN)  :: rawList
   CHARACTER(LEN=*),  INTENT(IN)  :: delimiter
@@ -514,4 +558,5 @@
 !==============================================================================================================================
 LOGICAL FUNCTION strCount_m1(rawList, delimiter, nb, lSc) RESULT(lerr)
+  IMPLICIT NONE
   CHARACTER(LEN=*),     INTENT(IN)  :: rawList(:)
   CHARACTER(LEN=*),     INTENT(IN)  :: delimiter
@@ -530,4 +575,5 @@
 !==============================================================================================================================
 LOGICAL FUNCTION strCount_1m(rawList, delimiter, nb, lSc) RESULT(lerr)
+  IMPLICIT NONE
   CHARACTER(LEN=*),  INTENT(IN)  :: rawList
   CHARACTER(LEN=*),  INTENT(IN)  :: delimiter(:)
@@ -560,4 +606,5 @@
 !==============================================================================================================================
 LOGICAL FUNCTION strParse(rawList, delimiter, keys, n, vals) RESULT(lerr)
+  IMPLICIT NONE
   CHARACTER(LEN=*),                             INTENT(IN)  :: rawList, delimiter
   CHARACTER(LEN=maxlen), ALLOCATABLE,           INTENT(OUT) :: keys(:)
@@ -570,53 +617,69 @@
   r  = TRIM(ADJUSTL(rawList))
   nr = LEN_TRIM(r); IF(nr == 0) THEN; keys = ['']; RETURN; END IF
-  CALL strParse_prv(nk)                                              !--- COUNT THE ELEMENTS
-  ALLOCATE(keys(nk))
-  IF(PRESENT(vals)) THEN
-    ALLOCATE(vals(nk)); CALL strParse_prv(nk, keys, vals)            !--- PARSE THE KEYS
-  ELSE
-    CALL strParse_prv(nk, keys)                                      !--- PARSE THE KEYS
-  END IF
-  IF(PRESENT(n)) n = nk
+  nk = countK()                                                      !--- COUNT THE ELEMENTS
+  CALL parseK(keys)                                                  !--- PARSE THE KEYS
+  IF(PRESENT(vals)) CALL parseV(vals)                                !--- PARSE <key>=<val> PAIRS
+  IF(PRESENT(n)) n = nk                                              !--- RETURN THE NUMBER OF KEYS
 
 CONTAINS
 
 !------------------------------------------------------------------------------------------------------------------------------
-SUBROUTINE strParse_prv(nkeys, keys, vals)
-!--- * Get the number of elements after parsing ("nkeys" only is present)
-!--- * Parse the <key>=<val> pairs and store result in "keys" and "vals" (already allocated)
-  IMPLICIT NONE
-  INTEGER,                         INTENT(OUT) :: nkeys
-  CHARACTER(LEN=maxlen), OPTIONAL, INTENT(OUT) :: keys(:)
-  CHARACTER(LEN=maxlen), OPTIONAL, INTENT(OUT) :: vals(:)
-!------------------------------------------------------------------------------------------------------------------------------
-  INTEGER :: ib, ie
-  nkeys = 1; ib = 1
+INTEGER FUNCTION countK() RESULT(nkeys)
+!--- Get the number of elements after parsing.
+  IMPLICIT NONE
+!------------------------------------------------------------------------------------------------------------------------------
+  INTEGER :: ib, ie, nl
+  nkeys = 1; ib = 1; nl = LEN(delimiter)
   DO
     ie = INDEX(rawList(ib:nr), delimiter)+ib-1                       !--- Determine the next separator start index
     IF(ie == ib-1) EXIT
-    IF(PRESENT(keys)) keys(nkeys) = r(ib:ie-1)                       !--- Get the ikth key
-    IF(PRESENT(vals)) CALL parseKeys(keys(nkeys), vals(nkeys))       !--- Parse the ikth <key>=<val> pair
+    ib = ie + nl
+    DO WHILE(ANY([0, 9, 32] == IACHAR(r(ib:ib))) .AND. ib < nr)      !--- Skip blanks (ascii): NULL (0), TAB (9), SPACE (32)
+      ib = ib + 1
+    END DO     !--- Skip spaces before next chain
+    nkeys = nkeys+1
+  END DO
+END FUNCTION countK
+
+!------------------------------------------------------------------------------------------------------------------------------
+SUBROUTINE parseK(keys)
+!--- Parse the string separated by "delimiter" from "rawList" into "keys(:)"
+  IMPLICIT NONE
+  CHARACTER(LEN=maxlen), ALLOCATABLE, INTENT(OUT) :: keys(:)
+!------------------------------------------------------------------------------------------------------------------------------
+  INTEGER :: ib, ie, ik
+  ALLOCATE(keys(nk))
+  ib = 1
+  DO ik = 1, nk
+    ie = INDEX(rawList(ib:nr), delimiter)+ib-1                       !--- Determine the next separator start index
+    IF(ie == ib-1) EXIT
+    keys(ik) = r(ib:ie-1)                                            !--- Get the ikth key
     ib = ie + LEN(delimiter)
     DO WHILE(r(ib:ib) == ' ' .AND. ib < nr); ib = ib + 1; END DO     !--- Skip spaces before next chain
-    nkeys = nkeys+1
-  END DO
-  IF(PRESENT(keys)) keys(nkeys) = r(ib:nr)                           !--- Get the last key
-  IF(PRESENT(vals)) CALL parseKeys(keys(nkeys), vals(nkeys))         !--- Parse the last <key>=<val> pair
-END SUBROUTINE strParse_prv
-
-!------------------------------------------------------------------------------------------------------------------------------
-SUBROUTINE parseKeys(key, val)
-  CHARACTER(LEN=*), INTENT(INOUT) :: key
-  CHARACTER(LEN=*), INTENT(OUT)   :: val
-!------------------------------------------------------------------------------------------------------------------------------
-  INTEGER :: ix
-  ix = INDEX(key, '='); IF(ix == 0) RETURN                           !--- First "=" index in "key"
-  val = ADJUSTL(key(ix+1:LEN_TRIM(key)))
-  key = ADJUSTL(key(1:ix-1))
-END SUBROUTINE parseKeys
+  END DO
+  keys(ik) = r(ib:nr)                                                !--- Get the last key
+END SUBROUTINE parseK
+
+!------------------------------------------------------------------------------------------------------------------------------
+SUBROUTINE parseV(vals)
+!--- Parse the <key>=<val> pairs in "keys(:)" into "keys" and "vals"
+  IMPLICIT NONE
+  CHARACTER(LEN=maxlen), ALLOCATABLE, INTENT(OUT) :: vals(:)
+!------------------------------------------------------------------------------------------------------------------------------
+  CHARACTER(LEN=maxlen) :: key
+  INTEGER :: ik, ix
+  ALLOCATE(vals(nk))
+  DO ik = 1, nk; key = keys(ik)
+    vals(ik) = ''
+    ix = INDEX(key, '='); IF(ix == 0) CYCLE                          !--- First "=" index in "key"
+    vals(ik) = ADJUSTL(key(ix+1:LEN_TRIM(key)))
+    keys(ik) = ADJUSTL(key(1:ix-1))
+  END DO
+END SUBROUTINE parseV
 
 END FUNCTION strParse
 !==============================================================================================================================
 LOGICAL FUNCTION strParse_m(rawList, delimiter, keys, n, vals, lSc, id) RESULT(lerr)
+  IMPLICIT NONE
   CHARACTER(LEN=*),                             INTENT(IN)  :: rawList, delimiter(:)
   CHARACTER(LEN=maxlen),           ALLOCATABLE, INTENT(OUT) :: keys(:)  !--- Parsed keys vector
@@ -630,5 +693,6 @@
   LOGICAL :: ll
   ll = .FALSE.; IF(PRESENT(lSc)) ll = lSc
-  IF(test(fmsg("Couldn't parse list: non-numerical strings were found", ll=strCount_1m(rawList, delimiter, nk, ll)),lerr)) RETURN
+  lerr = strCount_1m(rawList, delimiter, nk, ll)
+  CALL msg("Couldn't parse list: non-numerical strings were found", ll=lerr); IF(lerr) RETURN
 
   !--- FEW ALLOCATIONS
@@ -643,5 +707,6 @@
   ib = 1
   DO ik = 1, nk-1
-    IF(test(fmsg('Non-numeric values found', ll=strIdx_prv(r, delimiter, ib, ie, jd, ll)),lerr)) RETURN
+    lerr = strIdx_prv(r, delimiter, ib, ie, jd, ll)
+    CALL msg('Non-numeric values found', ll=lerr); IF(lerr) RETURN
     keys(ik) = r(ib:ie-1)
     IF(PRESENT(vals)) CALL parseKeys(keys(ik), vals(ik))             !--- Parse a <key>=<val> pair
@@ -657,4 +722,5 @@
 !------------------------------------------------------------------------------------------------------------------------------
 SUBROUTINE parseKeys(key, val)
+  IMPLICIT NONE
   CHARACTER(LEN=*), INTENT(INOUT) :: key
   CHARACTER(LEN=*), INTENT(OUT)   :: val
@@ -674,4 +740,5 @@
 !==============================================================================================================================
 SUBROUTINE strReplace_1(str, key, val, lsurr)
+  IMPLICIT NONE
   CHARACTER(LEN=*),  INTENT(INOUT) :: str        !--- Main string
   CHARACTER(LEN=*),  INTENT(IN)    :: key, val   !--- "key" will be replaced by "val"
@@ -700,4 +767,5 @@
 !==============================================================================================================================
 SUBROUTINE strReplace_m(str, key, val, lsurr)
+  IMPLICIT NONE
   CHARACTER(LEN=*),  INTENT(INOUT) :: str(:)     !--- Main strings vector
   CHARACTER(LEN=*),  INTENT(IN)    :: key, val   !--- "key" will be replaced by "val"
